//+------------------------------------------------------------------+
//|                                            Cross Combined V2.mq4 |
//|                                        Copyright  2010, IND-PC  |
//|                                        http://www.IND-PC.com     |
//+------------------------------------------------------------------+
#property copyright "Aaron Peterson - IND-PC 2010   aaron@ind-pc.com"
#property link      "http://www.ind-pc.com"


extern   double     LotSize = 0.5;
extern   int        TrailingStop=20;
extern   double     MaxDrawDownPct = 2.0;
extern   int        Magic = 1010;
extern   string     TradeComment = "Cross Combined v2";
extern   int        Setting1=16;
extern   int        Setting2=5;
extern   int        Setting3=1000;
extern   int        Setting4 = 18;
extern   double     CrossLimit = 0.5;
extern   string     AcceptableTimeFrames="0=Chart Time,1= 1Min,2 = 5 Min, 3=15Min,4=30Min,5=1H,6=4H,7=Daily,8=Weekly";
extern   int        CheckingTimeFrame = 2;



static int timesThrough, step = 0;
static double fallBack = 0.0;
static double trailing = 0.0;

string values, upperComment = "";
double trailingStopWithMultiplier = 0;
static bool buy = false;
static bool sell = false;
datetime lastTime;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   timesThrough = 0;
//----  
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   
//----

upperComment = "";

int ticket, multiplier, found=0;
double orderSize, drawDown;

if(Digits == 2 || Digits == 4)
{
   multiplier = 1;
}
if(Digits == 3 || Digits == 5) 
{
   multiplier = 10;
}
if(Digits == 6) 
{
   multiplier = 100;   
}
if(Digits == 7) 
{
   multiplier = 1000;
}

if(TrailingStop > 0)
{
   CheckTrailingStop();
}

int timeFrame = 0;
switch(CheckingTimeFrame)
{
   case 1: timeFrame = 1;break;
   case 2: timeFrame = 5;break;
   case 3: timeFrame = 15;break;
   case 4: timeFrame = 30; break;
   case 5: timeFrame = 60; break;
   case 6: timeFrame = 240; break;
   case 7: timeFrame = 1440; break;
   case 8: timeFrame = 10080;break;
}


if(lastTime != iTime(Symbol(), timeFrame, 1))
{

double NoLag = iCustom(NULL, 0, "Cross1", 0,0);
double NoLagPrev = iCustom(NULL, 0, "Cross1", 0, 1);
double Tema = iCustom(NULL, 0, "Cross2", Setting1, 0, 0);
double TemaPrev = iCustom(NULL, 0, "Cross2", Setting1, 0, 1);
double iVar = iCustom(NULL, 0, "CrossLimit",Setting2, Setting3, 0,0);
double SSAEndPoint = iCustom(NULL, 0, "CrossSSA", Setting4, 0, 1); 

values = "Cross1 Value : " + DoubleToStr(NormalizeDouble(NoLag,5),5) + ", Cross2 Value : " + DoubleToStr(NormalizeDouble(Tema,5),5) + ", CrossSSA : " + DoubleToStr(NormalizeDouble(SSAEndPoint,4),4);



if( IsGreaterThan(Tema, NoLag, 0) && !buy && IsGreaterThan(Tema, SSAEndPoint,0) && IsGreaterThan(SSAEndPoint, NoLag, 0))//Cross for Buy
{
   found = CloseSellOrders();   
   ////Print("Done closing SELL items");
   sell = false;
   if(NoLagPrev < NoLag && iVar < CrossLimit )
   {
      //Buy
      if(timesThrough == 0)
      {
         buy = true;
         timesThrough = 1;
         //Print("Started on BUY");
         return(0);
      }
      //Print("Start Buy");
      int buyTick = BuyCross(found);
      if(buyTick == 0)
      {
         buy = true;
      }
   }   
}
else if(IsGreaterThan(NoLag, Tema, 0) && !sell && IsGreaterThan(SSAEndPoint, Tema, 0) && IsGreaterThan(NoLag, SSAEndPoint, 0))//Cross for Sell
{
   found = CloseBuyOrders();
   //Print("Done closing BUY items");
   buy = false;
   if(NoLagPrev > NoLag && iVar < CrossLimit )
   {
      if(timesThrough == 0)
      {
         sell = true;
         timesThrough = 1;
         //Print("Started on SELL");
         return(0);
       }
       //Print("Start Sell " + found);
       int tickSell = SellCross(found);
       if(tickSell == 0)
       {
         sell=true;
       }
       //Print("Done Buy");
   }
   else
   {
      CloseOrders();
   }

}
lastTime = iTime(Symbol(), timeFrame, 1);
}

   drawDown = CheckDrawDown();
   if(drawDown > 0)
   {    
      upperComment = upperComment + "\r\n" + "Current Drawdown : " + DoubleToStr(NormalizeDouble(drawDown,3),3) + "%";
   }

   if(trailing > 0)
   {
      upperComment = upperComment + "\r\n" + "TrailingStop set at: " + DoubleToStr(NormalizeDouble(trailing,5),5);
   }
   
   upperComment = values + "\r\n" + upperComment  + "\r\n" + "Buy = " + buy + " Sell = " + sell;
   Comment(upperComment);
   
   
   return(0);
  }
//+------------------------------------------------------------------+

bool IsGreaterThan(double x, double y, double dev)
{
   if(x > y)
   {
      if((x+dev) > y)
      {
         return(true);
      }
   }

   return(false);
}

void CloseOrders()
{
   for(int i=0; i<OrdersTotal(); i++)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == true && OrderMagicNumber() == Magic)
      {
         if(OrderSymbol()!= Symbol())
         {
            continue;
         }
         int ticket = OrderTicket();
         double orderSize = OrderLots();
            
         switch (OrderType())
         {
            case 0:
               OrderClose(ticket, orderSize, Bid, 2);
               break;
                  
            case 1:
               OrderClose(ticket, orderSize, Ask, 2);
               break;
         }
         upperComment  = upperComment + " : " + "Close";
      }
   }
}


double CheckTrailingStop()
{
      for(int i=0;i<OrdersTotal();i++) 
      {
         OrderSelect(i, SELECT_BY_POS, MODE_TRADES);

         if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber() == Magic)
         {
            if(OrderType()==OP_BUY)   //<-- Long position is opened
            {
               TrailOrder(OrderType()); return(0); //<-- Trailling the order
            }
            if(OrderType()==OP_SELL) //<-- Go to short position
            {
               TrailOrder(OrderType()); return(0); //<-- Trailling the order
            }
         }
      }
}
void TrailOrder(int type)
{
   if(trailingStopWithMultiplier>0)
   {
      if(OrderMagicNumber() == Magic)
      {
         if(type==OP_BUY)
         {
            if(Bid <= trailing)
            {
               CloseOrders();
               //Print("Order Closed due to reaching Trailing Stop");
            }
            else if(Bid - (trailingStopWithMultiplier*Point) > trailing)
            {
               trailing = Bid - (trailingStopWithMultiplier*Point);
            }
         }
         if(type==OP_SELL)
         {
            if(Ask >= trailing)
            {
               CloseOrders();
               //Print("Order Closed due to reaching Trailing Stop");
            }
            else if(Ask + (trailingStopWithMultiplier*Point) < trailing)
            {
               trailing = Ask + (trailingStopWithMultiplier*Point);
            }
         }
      }
   }
}

double CheckDrawDown()
{
   double currentProfit = 0.0;
   for(int i=0; i<OrdersTotal(); i++)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == true && OrderMagicNumber() == Magic)
      {
         if(OrderSymbol()== Symbol())
         {
            currentProfit = currentProfit + OrderProfit() + OrderCommission() + OrderSwap();
            if((currentProfit / AccountBalance()) * (-100) > MaxDrawDownPct)
            {
               CloseOrders();
               //Print("Order Closed due to  reaching Maximum Drawdown");
            }
          }
      }
   }  
   return((currentProfit / AccountBalance()) * (-100));
}

int BuyCross(int found)
{
   if(found==0)
   {
      int tickBuy = OrderSend(Symbol(), OP_BUY, LotSize, Ask, 3, 0, 0,TradeComment, Magic, 0, Blue);
      //trailing = Ask - (trailingStopWithMultiplier*Point);
      if(tickBuy < 0)
      {
         return(1);
      }
   }    
   upperComment = upperComment + "\r\n" + "Buy" + " : FallBack = $" + DoubleToStr(NormalizeDouble(fallBack,2),2);
   return(0);
}

int SellCross(int found)
{
   if(found == 0)
   {
      int tickSell = OrderSend(Symbol(), OP_SELL,LotSize, Bid, 3, 0, 0, TradeComment, Magic, 0, Red);
      //trailing = Bid + (trailingStopWithMultiplier*Point);
      if(tickSell < 0)
      {
         return(1);
      }
   }
   upperComment = upperComment + "\r\n" + "Sell" + " : FallBack = $" + DoubleToStr(NormalizeDouble(fallBack,2),2);
   return(0);
}

int CloseSellOrders()
{
   int ticket, found = 0;
   double orderSize;
   for(int i=0; i<OrdersTotal(); i++)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == true && OrderMagicNumber() == Magic)
      {
         if(OrderSymbol()== Symbol())
         {
            
            ticket = OrderTicket();
            orderSize = OrderLots();
            if(OrderType() == OP_SELL)
            {
               RefreshRates();
               OrderClose(ticket, orderSize, Bid, 10);
               ////Print("Order closed due to TEMA Greater Than NoLag");
            }
            else if(OrderType() == OP_BUY)
            {
               found++;
            }
         }
      }
   }
   return(found);
}

int CloseBuyOrders()
{
   int ticket, found = 0;
   double orderSize;
   for(int i=0; i<OrdersTotal(); i++)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == true && OrderMagicNumber() == Magic)
      {
         if(OrderSymbol()== Symbol())
         {
            
            ticket = OrderTicket();
            orderSize = OrderLots();
            if(OrderType() ==OP_BUY)
            {
               OrderClose(ticket, orderSize, Ask, 10);
               ////Print("Order closed due to TEMA Less Than NoLag");
            }
            else if(OrderType() == OP_SELL)
            {
               found++;
            }
         }
         
      }
   }
   return(found);
}


